import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import _initializerDefineProperty from "@babel/runtime/helpers/initializerDefineProperty";
import _applyDecoratedDescriptor from "@babel/runtime/helpers/applyDecoratedDescriptor";
import _initializerWarningHelper from "@babel/runtime/helpers/initializerWarningHelper";

var _dec, _dec2, _class, _class2, _descriptor, _class3, _temp;

import _regeneratorRuntime from "@babel/runtime/regenerator";
import { inject, injectable } from 'inversify';
import { SHAPE, Renderable } from '@antv/g';
import { ImagePool } from './shapes/ImagePool';
export var LoadImagePlugin = (_dec = injectable(), _dec2 = inject(ImagePool), _dec(_class = (_class2 = (_temp = _class3 = /*#__PURE__*/function () {
  function LoadImagePlugin() {
    _initializerDefineProperty(this, "imagePool", _descriptor, this);
  }

  var _proto = LoadImagePlugin.prototype;

  _proto.apply = function apply(renderingService) {
    var _this = this;

    renderingService.hooks.mounted.tap(LoadImagePlugin.tag, /*#__PURE__*/function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(object) {
        var nodeType, attributes, _attributes$width, width, _attributes$height, height, img;

        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                nodeType = object.nodeType, attributes = object.attributes;

                if (!(nodeType === SHAPE.Image)) {
                  _context.next = 6;
                  break;
                }

                _attributes$width = attributes.width, width = _attributes$width === void 0 ? 0 : _attributes$width, _attributes$height = attributes.height, height = _attributes$height === void 0 ? 0 : _attributes$height, img = attributes.img;
                _context.next = 5;
                return _this.imagePool.getOrCreateImage(img, width, height);

              case 5:
                // set dirty rectangle flag
                object.getEntity().getComponent(Renderable).dirty = true;

              case 6:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }());
    renderingService.hooks.attributeChanged.tap(LoadImagePlugin.tag, /*#__PURE__*/function () {
      var _ref2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2(object, name, value) {
        var nodeType;
        return _regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                nodeType = object.nodeType;

                if (!(nodeType === SHAPE.Image)) {
                  _context2.next = 6;
                  break;
                }

                if (!(name === 'img')) {
                  _context2.next = 6;
                  break;
                }

                _context2.next = 5;
                return _this.imagePool.getOrCreateImage(value);

              case 5:
                // set dirty rectangle flag
                object.getEntity().getComponent(Renderable).dirty = true;

              case 6:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }));

      return function (_x2, _x3, _x4) {
        return _ref2.apply(this, arguments);
      };
    }());
  };

  return LoadImagePlugin;
}(), _class3.tag = 'LoadImagePlugin', _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "imagePool", [_dec2], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: null
})), _class2)) || _class);
//# sourceMappingURL=LoadImagePlugin.js.map