import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";

var _dec, _class;

import _regeneratorRuntime from "@babel/runtime/regenerator";
import { injectable } from 'inversify';
export var ImagePool = (_dec = injectable(), _dec(_class = /*#__PURE__*/function () {
  function ImagePool() {
    this.imageCache = {};
  }

  var _proto = ImagePool.prototype;

  _proto.getImageSync = function getImageSync(src) {
    return this.imageCache[src];
  };

  _proto.getOrCreateImage = /*#__PURE__*/function () {
    var _getOrCreateImage = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(src, width, height) {
      var _this = this;

      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (!(typeof src === 'string')) {
                _context.next = 6;
                break;
              }

              if (!this.imageCache[src]) {
                _context.next = 3;
                break;
              }

              return _context.abrupt("return", this.imageCache[src]);

            case 3:
              return _context.abrupt("return", new Promise(function (resolve, reject) {
                var image = new Image();

                image.onload = function () {
                  resolve(image);
                };

                image.onerror = function (ev) {
                  reject(ev);
                };

                image.crossOrigin = 'Anonymous';
                image.src = src;
                _this.imageCache[src] = image;
              }));

            case 6:
              if (width) {
                src.width = width;
              }

              if (height) {
                src.height = height;
              }

              return _context.abrupt("return", src);

            case 9:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    function getOrCreateImage(_x, _x2, _x3) {
      return _getOrCreateImage.apply(this, arguments);
    }

    return getOrCreateImage;
  }();

  return ImagePool;
}()) || _class);
//# sourceMappingURL=ImagePool.js.map