import { parseRadius } from '../../utils/parse';
export function generatePath(context, attributes) {
  var _attributes$radius = attributes.radius,
      radius = _attributes$radius === void 0 ? 0 : _attributes$radius,
      _attributes$width = attributes.width,
      width = _attributes$width === void 0 ? 0 : _attributes$width,
      _attributes$height = attributes.height,
      height = _attributes$height === void 0 ? 0 : _attributes$height;
  context.beginPath();

  if (radius === 0) {
    context.rect(0, 0, width, height);
  } else {
    var _parseRadius = parseRadius(radius),
        r1 = _parseRadius[0],
        r2 = _parseRadius[1],
        r3 = _parseRadius[2],
        r4 = _parseRadius[3];

    context.moveTo(r1, 0);
    context.lineTo(width - r2, 0);
    r2 !== 0 && context.arc(width - r2, r2, r2, -Math.PI / 2, 0);
    context.lineTo(width, height - r3);
    r3 !== 0 && context.arc(width - r3, height - r3, r3, 0, Math.PI / 2);
    context.lineTo(r4, height);
    r4 !== 0 && context.arc(r4, height - r4, r4, Math.PI / 2, Math.PI);
    context.lineTo(0, r1);
    r1 !== 0 && context.arc(r1, r1, r1, Math.PI, Math.PI * 1.5);
    context.closePath();
  }
}
//# sourceMappingURL=Rect.js.map