var _dec, _class;

import { injectable } from 'inversify';
import { isNil } from '@antv/util';
export var DefaultRenderer = (_dec = injectable(), _dec(_class = /*#__PURE__*/function () {
  function DefaultRenderer() {}

  var _proto = DefaultRenderer.prototype;

  _proto.render = function render(context, attributes) {
    var fill = attributes.fill,
        opacity = attributes.opacity,
        fillOpacity = attributes.fillOpacity,
        stroke = attributes.stroke,
        strokeOpacity = attributes.strokeOpacity,
        lineWidth = attributes.lineWidth,
        lineCap = attributes.lineCap,
        lineJoin = attributes.lineJoin;

    if (!isNil(fill)) {
      if (!isNil(fillOpacity) && fillOpacity !== 1) {
        context.globalAlpha = fillOpacity;
        context.fill();
        context.globalAlpha = opacity;
      } else {
        context.fill();
      }
    }

    if (!isNil(stroke)) {
      if (lineWidth && lineWidth > 0) {
        var applyOpacity = !isNil(strokeOpacity) && strokeOpacity !== 1;

        if (applyOpacity) {
          context.globalAlpha = strokeOpacity;
        }

        context.lineWidth = lineWidth;

        if (!isNil(lineCap)) {
          context.lineCap = lineCap;
        }

        if (!isNil(lineJoin)) {
          context.lineJoin = lineJoin;
        }

        context.stroke();
      }
    }
  };

  return DefaultRenderer;
}()) || _class);
//# sourceMappingURL=Default.js.map