import _initializerDefineProperty from "@babel/runtime/helpers/initializerDefineProperty";
import _applyDecoratedDescriptor from "@babel/runtime/helpers/applyDecoratedDescriptor";
import _initializerWarningHelper from "@babel/runtime/helpers/initializerWarningHelper";

var _dec, _dec2, _class, _class2, _descriptor;

import { inject, injectable } from 'inversify';
import { isNil } from '@antv/util';
import { ImagePool } from '../ImagePool';
export var ImageRenderer = (_dec = injectable(), _dec2 = inject(ImagePool), _dec(_class = (_class2 = /*#__PURE__*/function () {
  function ImageRenderer() {
    _initializerDefineProperty(this, "imagePool", _descriptor, this);
  }

  var _proto = ImageRenderer.prototype;

  _proto.render = function render(context, attributes) {
    var _attributes$width = attributes.width,
        width = _attributes$width === void 0 ? 0 : _attributes$width,
        _attributes$height = attributes.height,
        height = _attributes$height === void 0 ? 0 : _attributes$height,
        img = attributes.img,
        sx = attributes.sx,
        sy = attributes.sy,
        swidth = attributes.swidth,
        sheight = attributes.sheight,
        _attributes$anchor = attributes.anchor,
        anchor = _attributes$anchor === void 0 ? [0, 0] : _attributes$anchor; // image has been loaded in `mounted` hook

    var image = this.imagePool.getImageSync(img);

    if (!isNil(sx) && !isNil(sy) && !isNil(swidth) && !isNil(sheight)) {
      context.drawImage(image, sx, sy, swidth, sheight, -anchor[0] * width, -anchor[1] * height, width, height);
    } else {
      context.drawImage(image, -anchor[0] * width, -anchor[1] * height, width, height);
    }
  };

  return ImageRenderer;
}(), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "imagePool", [_dec2], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: null
})), _class2)) || _class);
//# sourceMappingURL=Image.js.map