"use strict";
exports.__esModule = true;
exports.containerModule = exports.PathGenerator = exports.PathGeneratorFactory = void 0;
var g_1 = require("@antv/g");
var inversify_1 = require("inversify");
var styles_1 = require("./shapes/styles");
var Image_1 = require("./shapes/styles/Image");
var StyleParser_1 = require("./shapes/StyleParser");
var ImagePool_1 = require("./shapes/ImagePool");
var paths_1 = require("./shapes/paths");
exports.PathGeneratorFactory = paths_1.PathGeneratorFactory;
exports.PathGenerator = paths_1.PathGenerator;
var Text_1 = require("./shapes/styles/Text");
var CanvasRendererPlugin_1 = require("./CanvasRendererPlugin");
var LoadImagePlugin_1 = require("./LoadImagePlugin");
/**
 * register shape renderers
 */
g_1.container.bind(paths_1.PathGeneratorFactory).toFactory(function (ctx) { return function (tagName) {
    if (tagName === g_1.SHAPE.Circle) {
        return paths_1.CirclePath;
    }
    else if (tagName === g_1.SHAPE.Ellipse) {
        return paths_1.EllipsePath;
    }
    else if (tagName === g_1.SHAPE.Rect) {
        return paths_1.RectPath;
    }
    else if (tagName === g_1.SHAPE.Line) {
        return paths_1.LinePath;
    }
    else if (tagName === g_1.SHAPE.Polyline) {
        return paths_1.PolylinePath;
    }
    else if (tagName === g_1.SHAPE.Polygon) {
        return paths_1.PolygonPath;
    }
    else if (tagName === g_1.SHAPE.Path) {
        return paths_1.PathPath;
    }
    return null;
}; });
exports.containerModule = new inversify_1.ContainerModule(function (bind, unbind, isBound, rebind) {
    bind(ImagePool_1.ImagePool).toSelf().inSingletonScope();
    bind(styles_1.DefaultRenderer).toSelf().inSingletonScope();
    bind(Image_1.ImageRenderer).toSelf().inSingletonScope();
    bind(Text_1.TextRenderer).toSelf().inSingletonScope();
    bind(styles_1.StyleRendererFactory).toFactory(function (ctx) { return function (tagName) {
        if (tagName === g_1.SHAPE.Circle ||
            tagName === g_1.SHAPE.Ellipse ||
            tagName === g_1.SHAPE.Rect ||
            tagName === g_1.SHAPE.Line ||
            tagName === g_1.SHAPE.Polyline ||
            tagName === g_1.SHAPE.Polygon ||
            tagName === g_1.SHAPE.Path) {
            return ctx.container.get(styles_1.DefaultRenderer);
        }
        else if (tagName === g_1.SHAPE.Image) {
            return ctx.container.get(Image_1.ImageRenderer);
        }
        else if (tagName === g_1.SHAPE.Text) {
            return ctx.container.get(Text_1.TextRenderer);
        }
        return null;
    }; });
    bind(StyleParser_1.StyleParser).toSelf().inSingletonScope();
    bind(CanvasRendererPlugin_1.CanvasRendererPlugin).toSelf().inSingletonScope();
    bind(g_1.RenderingPluginContribution).toService(CanvasRendererPlugin_1.CanvasRendererPlugin);
    bind(LoadImagePlugin_1.LoadImagePlugin).toSelf().inSingletonScope();
    bind(g_1.RenderingPluginContribution).toService(LoadImagePlugin_1.LoadImagePlugin);
});
