"use strict";
exports.__esModule = true;
exports.generatePath = void 0;
var parse_1 = require("../../utils/parse");
function generatePath(context, attributes) {
    var _a = attributes.radius, radius = _a === void 0 ? 0 : _a, _b = attributes.width, width = _b === void 0 ? 0 : _b, _c = attributes.height, height = _c === void 0 ? 0 : _c;
    context.beginPath();
    if (radius === 0) {
        context.rect(0, 0, width, height);
    }
    else {
        var _d = parse_1.parseRadius(radius), r1 = _d[0], r2 = _d[1], r3 = _d[2], r4 = _d[3];
        context.moveTo(r1, 0);
        context.lineTo(width - r2, 0);
        r2 !== 0 && context.arc(width - r2, r2, r2, -Math.PI / 2, 0);
        context.lineTo(width, height - r3);
        r3 !== 0 && context.arc(width - r3, height - r3, r3, 0, Math.PI / 2);
        context.lineTo(r4, height);
        r4 !== 0 && context.arc(r4, height - r4, r4, Math.PI / 2, Math.PI);
        context.lineTo(0, r1);
        r1 !== 0 && context.arc(r1, r1, r1, Math.PI, Math.PI * 1.5);
        context.closePath();
    }
}
exports.generatePath = generatePath;
