"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
exports.__esModule = true;
exports.DefaultRenderer = void 0;
var inversify_1 = require("inversify");
var util_1 = require("@antv/util");
var DefaultRenderer = /** @class */ (function () {
    function DefaultRenderer() {
    }
    DefaultRenderer.prototype.render = function (context, attributes) {
        var fill = attributes.fill, opacity = attributes.opacity, fillOpacity = attributes.fillOpacity, stroke = attributes.stroke, strokeOpacity = attributes.strokeOpacity, lineWidth = attributes.lineWidth, lineCap = attributes.lineCap, lineJoin = attributes.lineJoin;
        if (!util_1.isNil(fill)) {
            if (!util_1.isNil(fillOpacity) && fillOpacity !== 1) {
                context.globalAlpha = fillOpacity;
                context.fill();
                context.globalAlpha = opacity;
            }
            else {
                context.fill();
            }
        }
        if (!util_1.isNil(stroke)) {
            if (lineWidth && lineWidth > 0) {
                var applyOpacity = !util_1.isNil(strokeOpacity) && strokeOpacity !== 1;
                if (applyOpacity) {
                    context.globalAlpha = strokeOpacity;
                }
                context.lineWidth = lineWidth;
                if (!util_1.isNil(lineCap)) {
                    context.lineCap = lineCap;
                }
                if (!util_1.isNil(lineJoin)) {
                    context.lineJoin = lineJoin;
                }
                context.stroke();
            }
        }
    };
    DefaultRenderer = __decorate([
        inversify_1.injectable()
    ], DefaultRenderer);
    return DefaultRenderer;
}());
exports.DefaultRenderer = DefaultRenderer;
