"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
exports.__esModule = true;
exports.ImageRenderer = void 0;
var inversify_1 = require("inversify");
var util_1 = require("@antv/util");
var ImagePool_1 = require("../ImagePool");
var ImageRenderer = /** @class */ (function () {
    function ImageRenderer() {
    }
    ImageRenderer.prototype.render = function (context, attributes) {
        var _a = attributes.width, width = _a === void 0 ? 0 : _a, _b = attributes.height, height = _b === void 0 ? 0 : _b, img = attributes.img, sx = attributes.sx, sy = attributes.sy, swidth = attributes.swidth, sheight = attributes.sheight, _c = attributes.anchor, anchor = _c === void 0 ? [0, 0] : _c;
        // image has been loaded in `mounted` hook
        var image = this.imagePool.getImageSync(img);
        if (!util_1.isNil(sx) && !util_1.isNil(sy) && !util_1.isNil(swidth) && !util_1.isNil(sheight)) {
            context.drawImage(image, sx, sy, swidth, sheight, -anchor[0] * width, -anchor[1] * height, width, height);
        }
        else {
            context.drawImage(image, -anchor[0] * width, -anchor[1] * height, width, height);
        }
    };
    __decorate([
        inversify_1.inject(ImagePool_1.ImagePool)
    ], ImageRenderer.prototype, "imagePool");
    ImageRenderer = __decorate([
        inversify_1.injectable()
    ], ImageRenderer);
    return ImageRenderer;
}());
exports.ImageRenderer = ImageRenderer;
